//**************************************************************************//
//***                 Efficiency Arrows Alerts TT [x3]                     ***
//**************************************************************************//
#property copyright   "  Tankk,  29  july  2016,  http://forexsystems.ru/" 
#property link        "http://forexsystemsru.com/indikatory-foreks-f41/" 
#property description "Copyright  2006, Forex-TSD.com  ==  http://www.forex-tsd.com/"
#property description "Written by IgorAD,igorad2003@yahoo.co.uk   http://finance.groups.yahoo.com/group/TrendLaboratory"
#property description " * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * "
#property description " Moving Average         ." 
#property description " "
#property description ": ,  EFF,     - 3 ."
//#property version   "3.00"

#property indicator_separate_window
#property indicator_buffers 2

#property indicator_color1 SkyBlue
#property indicator_color2 Tomato

#property indicator_width1 2
#property indicator_width2 1
#property indicator_style2 2

#property indicator_level1 0
#property indicator_level2 -60
#property indicator_level3 60
#property indicator_levelcolor DarkSlateGray  // SteelBlue //C'60,61,62' // 
#property indicator_levelstyle STYLE_DOT

//#property indicator_minimum -100
//#property indicator_maximum  100 

enum nsmd { ZERO, ONE, TWO };
enum artp { NoArrows, EFFCrossZero, EFFCrossLevels, EFFCrossSmoth }; 
//**************************************************************************//
//                   Custom indicator input parameters                      // 
//**************************************************************************//

extern int                Length  =  10;            // Period of NonLagMA
extern ENUM_APPLIED_PRICE  Price  =  PRICE_CLOSE;   // Apply to Price(0-Close;1-Open;2-High;3-Low;4-Median price;5-Typical price;6-Weighted Close) 
extern int                ShiftM  =  0;
extern int                Smooth  =  5;             // Period of Smoothing MA  
extern ENUM_MA_METHOD  SmothMode  =  MODE_SMA;      // Mode of Smoothing MA 
extern int                ShiftS  =  0;
extern nsmd            NoiseMode  =  ZERO;          // Mode of Calculation of Noise

extern bool             EFFHisto  =  false;
extern int            CrossLevel  =  60;
extern artp           ShowArrows  =  EFFCrossZero;  
extern color             ArrowUP  =  LightCyan,   //Lavender,    //FireBrick,       //Red,
                         ArrowDN  =  Red;        //Magenta;     //DarkGreen;       //Lime
extern int             ArrowSize  =  1;   
extern int              ArrowGap  =  3,            //  High/Low  (4- )     
                           ArrUP  =  233,   //225
                           ArrDN  =  234;   //226
                               
extern bool        AlertsMessage  =  true,   //false,    //  "EFFCrossLevels"   4 , ..  : 2  0  2  0    :))
                     AlertsSound  =  true,   //false,
                     AlertsEmail  =  false,
                    AlertsMobile  =  false;
extern string          SoundFile  =  "news.wav";   //"stops.wav"   //"alert2.wav"   //"expert.wav"

//**************************************************************************//
//                        Custom indicator buffers                          //  
//**************************************************************************//
double EFF[], SMOOTH[], DELTG[];   int TimeBar=0; 
double First1[], First2[], Secnd1[], Secnd2[];
//**************************************************************************//
//               Custom indicator initialization function                   //
//**************************************************************************//

int init()
{
   IndicatorBuffers(7);   IndicatorDigits(3);

   SetIndexBuffer(0,EFF);
   SetIndexBuffer(1,SMOOTH);
   SetIndexBuffer(2,DELTG);
   
   SetIndexBuffer(3,First1); 
   SetIndexBuffer(4,First2);       
   SetIndexBuffer(5,Secnd1);
   SetIndexBuffer(6,Secnd2);   
   
//---- indicator line
   if (EFFHisto) int ELT = DRAW_HISTOGRAM;   else ELT = DRAW_LINE;  
   SetIndexStyle(0,ELT);
   SetIndexStyle(1,DRAW_LINE);
   
//----
   SetIndexShift(0,ShiftM);
   SetIndexShift(1,ShiftS);
   
   SetIndexDrawBegin(0,Length+Smooth);
   SetIndexDrawBegin(1,Length+Smooth);
   SetIndexDrawBegin(2,Length+Smooth);
   
//---- name for DataWindow and indicator subwindow label
   SetIndexLabel(0,"EFF ["+Length+"]");
   SetIndexLabel(1,"Smooth ["+Smooth+"]");

   IndicatorShortName("Efficiency TT ["+Length+","+Smooth+"]");   
//-------
//---
return(0);
}
//**************************************************************************//
//                 Custom indicator deinitialization function               //
//**************************************************************************//
int deinit() 
{
   ARROWS_DELETE();
   return(0);
}

void ARROWS_DELETE()   //EnumToString(ShowArrows)+
{
   string name;   string pref="Efficiency ["+Length+","+Smooth+"]_";
   for (int a=ObjectsTotal()-1; a>=0; a--) 
     {
      name=ObjectName(a);
      if (StringSubstr(name,0,StringLen(pref))==pref) ObjectDelete(name);
     }
}
//**************************************************************************//
//                   Custom indicator iteration function                    //
//**************************************************************************//
int start()
{
   int   i, k, limit, counted_bars=IndicatorCounted();
   if ( counted_bars > 0 )  limit=Bars-counted_bars;
   if ( counted_bars < 0 )  return(0);
   if ( counted_bars ==0 )  limit=Bars-1; 
   if ( counted_bars < 1 ) 
   
   for(i=1; i<Length+Smooth; i++) 
     {
      EFF[Bars-i]=0;    
      SMOOTH[Bars-i]=0;  
     }
   
   for(k=limit; k>=0; k--) 
     {	
      DELTG[k] = iMA(NULL,0,1,0,0,Price,k) - iMA(NULL,0,1,0,0,Price,k+1);
   
      if (NoiseMode==ZERO)
       { 
        double Noise=0;
        for (i=0; i<=Length-1; i++) Noise += MathAbs(DELTG[k+i]);
       }
       
      else if (NoiseMode==ONE)
         Noise = High[Highest(NULL,0,MODE_HIGH,Length,k)] - Low[Lowest(NULL,0,MODE_LOW,Length,k)];
   
      else if (NoiseMode==TWO)
       { 
        Noise=0;
        for (i=0; i<=Length-1; i++) Noise += (High[k+i] - Low[k+i]);
       }
               
      if (Noise > 0) EFF[k] = 100*(iMA(NULL,0,1,0,0,Price,k) - iMA(NULL,0,1,0,0,Price,k+Length)) /Noise;
     }
//**************************************************************************//
//***                 Efficiency Arrows Alerts TT [x3]                     ***
//**************************************************************************//

   for(k=limit; k>=0; k--)   
     {
      SMOOTH[k] = iMAOnArray(EFF,0,Smooth,0,SmothMode,k);  
//enum artp { NoArrows, EFFCrossZero, EFFCrossLevels, EFFCrossSmoth }; 

        if (ShowArrows==EFFCrossZero)
         {
          if (EFF[k+1] < 0 && EFF[k+2] > 0)   manageArr(k,"Arrow DN",ArrowDN,ArrDN,ArrowSize,true );
          if (EFF[k+1] > 0 && EFF[k+2] < 0)   manageArr(k,"Arrow UP",ArrowUP,ArrUP,ArrowSize,false);
         }
         
        if (ShowArrows==EFFCrossLevels)
         {
          if (EFF[k+1] < CrossLevel && EFF[k+2] > CrossLevel)   manageArr(k,"Arrow DN",ArrowDN,ArrDN,ArrowSize,true );
          if (EFF[k+1] > -CrossLevel && EFF[k+2] < -CrossLevel)   manageArr(k,"Arrow UP",ArrowUP,ArrUP,ArrowSize,false);
         }

        if (ShowArrows==EFFCrossSmoth)
         {
          if (EFF[k+1] < SMOOTH[k+1] && EFF[k+2] > SMOOTH[k+2])   manageArr(k,"Arrow DN",ArrowDN,ArrDN,ArrowSize,true );
          if (EFF[k+1] > SMOOTH[k+1] && EFF[k+2] < SMOOTH[k+2])   manageArr(k,"Arrow UP",ArrowUP,ArrUP,ArrowSize,false);
         }
//**************************************************************************//

  if (ShowArrows==EFFCrossZero || ShowArrows==EFFCrossLevels || ShowArrows==EFFCrossSmoth)
   {        
    if (AlertsMessage || AlertsEmail || AlertsMobile || AlertsSound) 
     {
       if (ShowArrows==EFFCrossZero)     { First1[k+1]=EFF[k+1];  First2[k+2]=EFF[k+2];  Secnd1[k+1]=0; Secnd2[k+2]=0; }
       if (ShowArrows==EFFCrossLevels)   { First1[k+1]=EFF[k+1];  First2[k+2]=EFF[k+2];  if (EFF[k+2] > 0) {Secnd1[k+1]=CrossLevel; Secnd2[k+2]=CrossLevel;}  if (EFF[k+2] < 0) {Secnd1[k+1]=-CrossLevel; Secnd2[k+2]=-CrossLevel;} }
       if (ShowArrows==EFFCrossSmoth)    { First1[k+1]=EFF[k+1];  First2[k+2]=EFF[k+2];  Secnd1[k+1]=SMOOTH[k+1]; Secnd2[k+2]=SMOOTH[k+2]; }
       
       string message;
       
       if (TimeBar!=Time[0] && (First1[1] < Secnd1[1] && First2[2] > Secnd2[2])) 
        {
         message =("Efficiency ["+Length+","+Smooth+"] - "+Symbol()+", TF ["+IntegerToString(Period())+"] = "+EnumToString(ShowArrows)+" <<<  Arrow DN  ==  SELL");   //BearsBulls Alerts MTF TT
         if (AlertsMessage) Alert(message);
         if (AlertsEmail)   SendMail(Symbol(),message);
         if (AlertsMobile)  SendNotification(message);
         if (AlertsSound)   PlaySound(SoundFile);   //"stops.wav"   //"news.wav"
         TimeBar=Time[0];
         //return(0);
        } 
          
       else if (TimeBar!=Time[0] && (First1[1] > Secnd1[1] && First2[2] < Secnd2[2])) 
        { 
         message =("Efficiency ["+Length+","+Smooth+"] - "+Symbol()+", TF ["+IntegerToString(Period())+"] = "+EnumToString(ShowArrows)+" >>>  Arrow UP  ==  BUY");   //BearsBulls Alerts MTF TT
         if (AlertsMessage) Alert(message);
         if (AlertsEmail)   SendMail(Symbol(),message);
         if (AlertsMobile)  SendNotification(message);
         if (AlertsSound)   PlaySound(SoundFile);   //"stops.wav"   //"news.wav"
         TimeBar=Time[0];
         //return(0);
        }
      }
   } 
//**************************************************************************//
     }
//----------   
//----
return(0);	
}
//**************************************************************************//

void manageArr(int z, string text, color Clr, int Code, int Size, bool DN)   
{
   string objName = "Efficiency ["+Length+","+Smooth+"]_"+text+"_"+Time[z]+"_"+Close[z];
   //double Gap = 2.0*iATR(NULL,0,20,z)/4.0;
   double Gap=ArrowGap*Point;   if (Digits==3 || Digits==5) Gap=ArrowGap*10*Point;
   
   ObjectCreate(objName, OBJ_ARROW,0,Time[z],0);
   ObjectSet   (objName, OBJPROP_TEXT, text);  
   ObjectSet   (objName, OBJPROP_COLOR, Clr);  
   ObjectSet   (objName, OBJPROP_ARROWCODE,Code);
   ObjectSet   (objName, OBJPROP_WIDTH,Size);  
   
   if (DN)
      ObjectSet(objName,OBJPROP_PRICE1,High[z]+Gap*1.3);   
      
     else  
      ObjectSet(objName,OBJPROP_PRICE1,Low[z] -Gap);
}
//**************************************************************************//
//***                 Efficiency Arrows Alerts TT [x3]                     ***
//**************************************************************************//
